using System;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design.Serialization;
using System.Globalization;
using System.Reflection;

namespace SharpDX.Design;

public class b : ExpandableObjectConverter
{
	private readonly PropertyDescriptorCollection m_a;

	public b()
	{
		Type typeFromHandle = typeof(at);
		PropertyDescriptor[] properties = new PropertyDescriptor[4]
		{
			new d(typeFromHandle.GetField("X")),
			new d(typeFromHandle.GetField("Y")),
			new d(typeFromHandle.GetField("Z")),
			new d(typeFromHandle.GetField("W"))
		};
		this.m_a = new PropertyDescriptorCollection(properties);
	}

	public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
	{
		if ((object)sourceType != typeof(string))
		{
			return base.CanConvertFrom(context, sourceType);
		}
		return true;
	}

	public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
	{
		if ((object)destinationType != typeof(string) && (object)destinationType != typeof(InstanceDescriptor))
		{
			return base.CanConvertTo(context, destinationType);
		}
		return true;
	}

	public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
	{
		if (culture == null)
		{
			culture = CultureInfo.CurrentCulture;
		}
		if (!(value is string text))
		{
			return base.ConvertFrom(context, culture, value);
		}
		string text2 = text.Trim();
		TypeConverter converter = TypeDescriptor.GetConverter(typeof(SharpDX.d));
		char[] separator = new char[1] { culture.TextInfo.ListSeparator[0] };
		string[] array = text2.Split(separator);
		if (array.Length != 4)
		{
			throw new ArgumentException("Invalid half format.");
		}
		SharpDX.d a_ = (SharpDX.d)converter.ConvertFromString(context, culture, array[0]);
		SharpDX.d a_2 = (SharpDX.d)converter.ConvertFromString(context, culture, array[1]);
		SharpDX.d a_3 = (SharpDX.d)converter.ConvertFromString(context, culture, array[2]);
		SharpDX.d a_4 = (SharpDX.d)converter.ConvertFromString(context, culture, array[3]);
		return new at(a_, a_2, a_3, a_4);
	}

	public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
	{
		if ((object)destinationType == null)
		{
			throw new ArgumentNullException("destinationType");
		}
		if (culture == null)
		{
			culture = CultureInfo.CurrentCulture;
		}
		if ((object)destinationType == typeof(string) && value is at)
		{
			TypeConverter converter = TypeDescriptor.GetConverter(typeof(SharpDX.d));
			return string.Join(culture.TextInfo.ListSeparator + " ", converter.ConvertToString(context, culture, ((at)value).a), converter.ConvertToString(context, culture, ((at)value).b), converter.ConvertToString(context, culture, ((at)value).c), converter.ConvertToString(context, culture, ((at)value).d));
		}
		if ((object)destinationType == typeof(InstanceDescriptor) && value is at)
		{
			ConstructorInfo constructor = typeof(at).GetConstructor(new Type[4]
			{
				typeof(SharpDX.d),
				typeof(SharpDX.d),
				typeof(SharpDX.d),
				typeof(SharpDX.d)
			});
			if ((object)constructor != null)
			{
				return new InstanceDescriptor(constructor, new object[4]
				{
					((at)value).a,
					((at)value).b,
					((at)value).c,
					((at)value).d
				});
			}
		}
		return base.ConvertTo(context, culture, value, destinationType);
	}

	public override object CreateInstance(ITypeDescriptorContext context, IDictionary propertyValues)
	{
		if (propertyValues == null)
		{
			throw new ArgumentNullException("propertyValues");
		}
		return new at((SharpDX.d)propertyValues["X"], (SharpDX.d)propertyValues["Y"], (SharpDX.d)propertyValues["Z"], (SharpDX.d)propertyValues["W"]);
	}

	public override bool GetCreateInstanceSupported(ITypeDescriptorContext context)
	{
		return true;
	}

	public virtual PropertyDescriptorCollection a(ITypeDescriptorContext A_0, object A_1, Attribute[] A_2)
	{
		return this.m_a;
	}

	public virtual bool a(ITypeDescriptorContext A_0)
	{
		return true;
	}
}
