using System;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design.Serialization;
using System.Globalization;
using System.Reflection;

namespace SharpDX.Design;

public class e : ExpandableObjectConverter
{
	private readonly PropertyDescriptorCollection m_a;

	public e()
	{
		Type typeFromHandle = typeof(av);
		PropertyDescriptor[] properties = new PropertyDescriptor[2]
		{
			new d(typeFromHandle.GetField("X")),
			new d(typeFromHandle.GetField("Y"))
		};
		this.m_a = new PropertyDescriptorCollection(properties);
	}

	public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
	{
		if ((object)sourceType != typeof(string))
		{
			return base.CanConvertFrom(context, sourceType);
		}
		return true;
	}

	public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
	{
		if ((object)destinationType != typeof(string) && (object)destinationType != typeof(InstanceDescriptor))
		{
			return base.CanConvertTo(context, destinationType);
		}
		return true;
	}

	public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
	{
		if (culture == null)
		{
			culture = CultureInfo.CurrentCulture;
		}
		if (!(value is string text))
		{
			return base.ConvertFrom(context, culture, value);
		}
		string text2 = text.Trim();
		TypeConverter converter = TypeDescriptor.GetConverter(typeof(SharpDX.d));
		char[] separator = new char[1] { culture.TextInfo.ListSeparator[0] };
		string[] array = text2.Split(separator);
		if (array.Length != 2)
		{
			throw new ArgumentException("Invalid half format.");
		}
		SharpDX.d a_ = (SharpDX.d)converter.ConvertFromString(context, culture, array[0]);
		SharpDX.d a_2 = (SharpDX.d)converter.ConvertFromString(context, culture, array[1]);
		return new av(a_, a_2);
	}

	public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
	{
		if ((object)destinationType == null)
		{
			throw new ArgumentNullException("destinationType");
		}
		if (culture == null)
		{
			culture = CultureInfo.CurrentCulture;
		}
		if ((object)destinationType == typeof(string) && value is av)
		{
			TypeConverter converter = TypeDescriptor.GetConverter(typeof(SharpDX.d));
			return string.Join(culture.TextInfo.ListSeparator + " ", converter.ConvertToString(context, culture, ((av)value).a), converter.ConvertToString(context, culture, ((av)value).b));
		}
		if ((object)destinationType == typeof(InstanceDescriptor) && value is av)
		{
			ConstructorInfo constructor = typeof(av).GetConstructor(new Type[2]
			{
				typeof(SharpDX.d),
				typeof(SharpDX.d)
			});
			if ((object)constructor != null)
			{
				return new InstanceDescriptor(constructor, new object[2]
				{
					((av)value).a,
					((av)value).b
				});
			}
		}
		return base.ConvertTo(context, culture, value, destinationType);
	}

	public override object CreateInstance(ITypeDescriptorContext context, IDictionary propertyValues)
	{
		if (propertyValues == null)
		{
			throw new ArgumentNullException("propertyValues");
		}
		return new av((SharpDX.d)propertyValues["X"], (SharpDX.d)propertyValues["Y"]);
	}

	public override bool GetCreateInstanceSupported(ITypeDescriptorContext context)
	{
		return true;
	}

	public virtual PropertyDescriptorCollection a(ITypeDescriptorContext A_0, object A_1, Attribute[] A_2)
	{
		return this.m_a;
	}

	public virtual bool a(ITypeDescriptorContext A_0)
	{
		return true;
	}
}
