using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace SharpDX.Multimedia;

[StructLayout(LayoutKind.Sequential, Pack = 2)]
public class b
{
	[StructLayout(LayoutKind.Sequential, Pack = 2)]
	internal struct a
	{
		public WaveFormatEncoding a;

		public short b;

		public int c;

		public int d;

		public short e;

		public short f;

		public short g;

		internal void a()
		{
		}
	}

	protected WaveFormatEncoding a;

	protected short b;

	protected int c;

	protected int d;

	protected short e;

	protected short f;

	protected short g;

	internal void a(ref a A_0)
	{
		this.a = A_0.a;
		this.b = A_0.b;
		this.c = A_0.c;
		this.d = A_0.d;
		this.e = A_0.e;
		this.f = A_0.f;
		this.g = A_0.g;
	}

	internal void b(ref a A_0)
	{
		A_0.a = this.a;
		A_0.b = this.b;
		A_0.c = this.c;
		A_0.d = this.d;
		A_0.e = this.e;
		A_0.f = this.f;
		A_0.g = this.g;
	}

	public b()
		: this(44100, 16, 2)
	{
	}

	public b(int A_0, int A_1)
		: this(A_0, 16, A_1)
	{
	}

	public int a(int A_0)
	{
		int num = (int)((double)f() / 1000.0 * (double)A_0);
		if (num % i() != 0)
		{
			num = num + i() - num % i();
		}
		return num;
	}

	public static b a(WaveFormatEncoding A_0, int A_1, int A_2, int A_3, int A_4, int A_5)
	{
		b b2 = new b();
		b2.a = A_0;
		b2.b = (short)A_2;
		b2.c = A_1;
		b2.d = A_3;
		b2.e = (short)A_4;
		b2.f = (short)A_5;
		b2.g = 0;
		return b2;
	}

	public static b c(int A_0, int A_1)
	{
		return a(WaveFormatEncoding.ALaw, A_0, A_1, A_0 * A_1, 1, 8);
	}

	public static b b(int A_0, int A_1)
	{
		return a(WaveFormatEncoding.MuLaw, A_0, A_1, A_0 * A_1, 1, 8);
	}

	public b(int A_0, int A_1, int A_2)
	{
		if (A_2 < 1)
		{
			throw new ArgumentOutOfRangeException("Channels must be 1 or greater", "channels");
		}
		this.a = ((A_1 < 32) ? WaveFormatEncoding.Pcm : WaveFormatEncoding.IeeeFloat);
		this.b = (short)A_2;
		this.c = A_0;
		this.f = (short)A_1;
		this.g = 0;
		this.e = (short)(A_2 * (A_1 / 8));
		this.d = this.c * this.e;
	}

	public static b a(int A_0, int A_1)
	{
		b b2 = new b();
		b2.a = WaveFormatEncoding.IeeeFloat;
		b2.b = (short)A_1;
		b2.f = 32;
		b2.c = A_0;
		b2.e = (short)(4 * A_1);
		b2.d = A_0 * b2.e;
		b2.g = 0;
		return b2;
	}

	public static b a(IntPtr A_0)
	{
		b b2 = (b)Marshal.PtrToStructure(A_0, typeof(b));
		switch (b2.h())
		{
		case WaveFormatEncoding.Pcm:
			b2.g = 0;
			break;
		case WaveFormatEncoding.Extensible:
			b2 = (SharpDX.Multimedia.a)Marshal.PtrToStructure(A_0, typeof(SharpDX.Multimedia.a));
			break;
		}
		return b2;
	}

	public static IntPtr a(b A_0)
	{
		int cb = Marshal.SizeOf((object)A_0);
		IntPtr intPtr = Marshal.AllocHGlobal(cb);
		Marshal.StructureToPtr((object)A_0, intPtr, fDeleteOld: false);
		return intPtr;
	}

	public b(BinaryReader A_0)
	{
		int num = A_0.ReadInt32();
		if (num < 16)
		{
			throw new ApplicationException("Invalid WaveFormat Structure");
		}
		this.a = (WaveFormatEncoding)A_0.ReadUInt16();
		this.b = A_0.ReadInt16();
		this.c = A_0.ReadInt32();
		this.d = A_0.ReadInt32();
		this.e = A_0.ReadInt16();
		this.f = A_0.ReadInt16();
		this.g = 0;
		if (num > 16)
		{
			this.g = A_0.ReadInt16();
			if (this.g > num - 18)
			{
				Console.WriteLine("Format chunk mismatch");
				this.g = (short)(num - 18);
			}
		}
	}

	public virtual string a()
	{
		WaveFormatEncoding waveFormatEncoding = this.a;
		if (waveFormatEncoding == WaveFormatEncoding.Pcm || waveFormatEncoding == WaveFormatEncoding.Extensible)
		{
			return $"{this.f} bit PCM: {this.c / 1000}kHz {this.b} channels";
		}
		return this.a.ToString();
	}

	public virtual bool a(object A_0)
	{
		if (!(A_0 is b))
		{
			return false;
		}
		b b2 = (b)A_0;
		if (this.a == b2.a && this.b == b2.b && this.c == b2.c && this.d == b2.d && this.e == b2.e)
		{
			return this.f == b2.f;
		}
		return false;
	}

	public virtual int e()
	{
		return (int)((uint)this.a ^ (uint)this.b ^ (uint)this.c ^ (uint)this.d ^ (uint)this.e) ^ (int)this.f;
	}

	[SpecialName]
	public WaveFormatEncoding h()
	{
		return this.a;
	}

	[SpecialName]
	public int g()
	{
		return this.b;
	}

	[SpecialName]
	public int d()
	{
		return this.c;
	}

	[SpecialName]
	public int f()
	{
		return this.d;
	}

	[SpecialName]
	public int i()
	{
		return this.e;
	}

	[SpecialName]
	public int j()
	{
		return this.f;
	}

	[SpecialName]
	public int c()
	{
		return this.g;
	}
}
