using System;
using System.ComponentModel;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using SharpDX.Design;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
[TypeConverter(typeof(SharpDX.Design.c))]
public struct a : IEquatable<a>, IFormattable
{
	public static readonly int a = Marshal.SizeOf(typeof(a));

	public static readonly a b = default(a);

	public static readonly a c = new a(1f, 0f, 0f);

	public static readonly a d = new a(0f, 1f, 0f);

	public static readonly a e = new a(0f, 0f, 1f);

	public static readonly a f = new a(1f, 1f, 1f);

	public float g;

	public float h;

	public float i;

	public a(float A_0)
	{
		this.g = A_0;
		this.h = A_0;
		this.i = A_0;
	}

	public a(float A_0, float A_1, float A_2)
	{
		this.g = A_0;
		this.h = A_1;
		this.i = A_2;
	}

	public a(au A_0, float A_1)
	{
		this.g = A_0.f;
		this.h = A_0.g;
		this.i = A_1;
	}

	public a(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 3)
		{
			throw new ArgumentOutOfRangeException("values", "There must be three and only three input values for Vector3.");
		}
		this.g = A_0[0];
		this.h = A_0[1];
		this.i = A_0[2];
	}

	[SpecialName]
	public bool c()
	{
		return Math.Abs(this.g * this.g + this.h * this.h + this.i * this.i - 1f) < 1E-06f;
	}

	[SpecialName]
	public float a(int A_0)
	{
		return A_0 switch
		{
			0 => this.g, 
			1 => this.h, 
			2 => this.i, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Vector3 run from 0 to 2, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.g = A_1;
			break;
		case 1:
			this.h = A_1;
			break;
		case 2:
			this.i = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Vector3 run from 0 to 2, inclusive.");
		}
	}

	public float e()
	{
		return (float)Math.Sqrt(this.g * this.g + this.h * this.h + this.i * this.i);
	}

	public float d()
	{
		return this.g * this.g + this.h * this.h + this.i * this.i;
	}

	public void a()
	{
		float num = e();
		if (num > 1E-06f)
		{
			float num2 = 1f / num;
			this.g *= num2;
			this.h *= num2;
			this.i *= num2;
		}
	}

	public float[] b()
	{
		return new float[3] { this.g, this.h, this.i };
	}

	public static void g(ref a A_0, ref a A_1, out a A_2)
	{
		A_2 = new a(A_0.g + A_1.g, A_0.h + A_1.h, A_0.i + A_1.i);
	}

	public static a n(a A_0, a A_1)
	{
		return new a(A_0.g + A_1.g, A_0.h + A_1.h, A_0.i + A_1.i);
	}

	public static void f(ref a A_0, ref a A_1, out a A_2)
	{
		A_2 = new a(A_0.g - A_1.g, A_0.h - A_1.h, A_0.i - A_1.i);
	}

	public static a m(a A_0, a A_1)
	{
		return new a(A_0.g - A_1.g, A_0.h - A_1.h, A_0.i - A_1.i);
	}

	public static void b(ref a A_0, float A_1, out a A_2)
	{
		A_2 = new a(A_0.g * A_1, A_0.h * A_1, A_0.i * A_1);
	}

	public static a d(a A_0, float A_1)
	{
		return new a(A_0.g * A_1, A_0.h * A_1, A_0.i * A_1);
	}

	public static void e(ref a A_0, ref a A_1, out a A_2)
	{
		A_2 = new a(A_0.g * A_1.g, A_0.h * A_1.h, A_0.i * A_1.i);
	}

	public static a l(a A_0, a A_1)
	{
		return new a(A_0.g * A_1.g, A_0.h * A_1.h, A_0.i * A_1.i);
	}

	public static void a(ref a A_0, float A_1, out a A_2)
	{
		A_2 = new a(A_0.g / A_1, A_0.h / A_1, A_0.i / A_1);
	}

	public static a c(a A_0, float A_1)
	{
		return new a(A_0.g / A_1, A_0.h / A_1, A_0.i / A_1);
	}

	public static void b(ref a A_0, out a A_1)
	{
		A_1 = new a(0f - A_0.g, 0f - A_0.h, 0f - A_0.i);
	}

	public static a f(a A_0)
	{
		return new a(0f - A_0.g, 0f - A_0.h, 0f - A_0.i);
	}

	public static void a(ref a A_0, ref a A_1, ref a A_2, float A_3, float A_4, out a A_5)
	{
		A_5 = new a(A_0.g + A_3 * (A_1.g - A_0.g) + A_4 * (A_2.g - A_0.g), A_0.h + A_3 * (A_1.h - A_0.h) + A_4 * (A_2.h - A_0.h), A_0.i + A_3 * (A_1.i - A_0.i) + A_4 * (A_2.i - A_0.i));
	}

	public static a a(a A_0, a A_1, a A_2, float A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, A_3, A_4, out var A_5);
		return A_5;
	}

	public static void a(ref a A_0, ref a A_1, ref a A_2, out a A_3)
	{
		float num = A_0.g;
		num = ((num > A_2.g) ? A_2.g : num);
		num = ((num < A_1.g) ? A_1.g : num);
		float num2 = A_0.h;
		num2 = ((num2 > A_2.h) ? A_2.h : num2);
		num2 = ((num2 < A_1.h) ? A_1.h : num2);
		float num3 = A_0.i;
		num3 = ((num3 > A_2.i) ? A_2.i : num3);
		num3 = ((num3 < A_1.i) ? A_1.i : num3);
		A_3 = new a(num, num2, num3);
	}

	public static a a(a A_0, a A_1, a A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void d(ref a A_0, ref a A_1, out a A_2)
	{
		A_2 = new a(A_0.h * A_1.i - A_0.i * A_1.h, A_0.i * A_1.g - A_0.g * A_1.i, A_0.g * A_1.h - A_0.h * A_1.g);
	}

	public static a k(a A_0, a A_1)
	{
		d(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void c(ref a A_0, ref a A_1, out float A_2)
	{
		float num = A_0.g - A_1.g;
		float num2 = A_0.h - A_1.h;
		float num3 = A_0.i - A_1.i;
		A_2 = (float)Math.Sqrt(num * num + num2 * num2 + num3 * num3);
	}

	public static float j(a A_0, a A_1)
	{
		float num = A_0.g - A_1.g;
		float num2 = A_0.h - A_1.h;
		float num3 = A_0.i - A_1.i;
		return (float)Math.Sqrt(num * num + num2 * num2 + num3 * num3);
	}

	public static void b(ref a A_0, ref a A_1, out float A_2)
	{
		float num = A_0.g - A_1.g;
		float num2 = A_0.h - A_1.h;
		float num3 = A_0.i - A_1.i;
		A_2 = num * num + num2 * num2 + num3 * num3;
	}

	public static float i(a A_0, a A_1)
	{
		float num = A_0.g - A_1.g;
		float num2 = A_0.h - A_1.h;
		float num3 = A_0.i - A_1.i;
		return num * num + num2 * num2 + num3 * num3;
	}

	public static void a(ref a A_0, ref a A_1, out float A_2)
	{
		A_2 = A_0.g * A_1.g + A_0.h * A_1.h + A_0.i * A_1.i;
	}

	public static float h(a A_0, a A_1)
	{
		return A_0.g * A_1.g + A_0.h * A_1.h + A_0.i * A_1.i;
	}

	public static void a(ref a A_0, out a A_1)
	{
		A_1 = A_0;
		A_1.a();
	}

	public static a e(a A_0)
	{
		A_0.a();
		return A_0;
	}

	public static void b(ref a A_0, ref a A_1, float A_2, out a A_3)
	{
		A_3.g = A_0.g + (A_1.g - A_0.g) * A_2;
		A_3.h = A_0.h + (A_1.h - A_0.h) * A_2;
		A_3.i = A_0.i + (A_1.i - A_0.i) * A_2;
	}

	public static a b(a A_0, a A_1, float A_2)
	{
		b(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref a A_0, ref a A_1, float A_2, out a A_3)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		A_3.g = A_0.g + (A_1.g - A_0.g) * A_2;
		A_3.h = A_0.h + (A_1.h - A_0.h) * A_2;
		A_3.i = A_0.i + (A_1.i - A_0.i) * A_2;
	}

	public static a a(a A_0, a A_1, float A_2)
	{
		a(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void b(ref a A_0, ref a A_1, ref a A_2, ref a A_3, float A_4, out a A_5)
	{
		float num = A_4 * A_4;
		float num2 = A_4 * num;
		float num3 = 2f * num2 - 3f * num + 1f;
		float num4 = -2f * num2 + 3f * num;
		float num5 = num2 - 2f * num + A_4;
		float num6 = num2 - num;
		A_5.g = A_0.g * num3 + A_2.g * num4 + A_1.g * num5 + A_3.g * num6;
		A_5.h = A_0.h * num3 + A_2.h * num4 + A_1.h * num5 + A_3.h * num6;
		A_5.i = A_0.i * num3 + A_2.i * num4 + A_1.i * num5 + A_3.i * num6;
	}

	public static a b(a A_0, a A_1, a A_2, a A_3, float A_4)
	{
		b(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static void a(ref a A_0, ref a A_1, ref a A_2, ref a A_3, float A_4, out a A_5)
	{
		float num = A_4 * A_4;
		float num2 = A_4 * num;
		A_5.g = 0.5f * (2f * A_1.g + (0f - A_0.g + A_2.g) * A_4 + (2f * A_0.g - 5f * A_1.g + 4f * A_2.g - A_3.g) * num + (0f - A_0.g + 3f * A_1.g - 3f * A_2.g + A_3.g) * num2);
		A_5.h = 0.5f * (2f * A_1.h + (0f - A_0.h + A_2.h) * A_4 + (2f * A_0.h - 5f * A_1.h + 4f * A_2.h - A_3.h) * num + (0f - A_0.h + 3f * A_1.h - 3f * A_2.h + A_3.h) * num2);
		A_5.i = 0.5f * (2f * A_1.i + (0f - A_0.i + A_2.i) * A_4 + (2f * A_0.i - 5f * A_1.i + 4f * A_2.i - A_3.i) * num + (0f - A_0.i + 3f * A_1.i - 3f * A_2.i + A_3.i) * num2);
	}

	public static a a(a A_0, a A_1, a A_2, a A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static void c(ref a A_0, ref a A_1, out a A_2)
	{
		A_2.g = ((A_0.g > A_1.g) ? A_0.g : A_1.g);
		A_2.h = ((A_0.h > A_1.h) ? A_0.h : A_1.h);
		A_2.i = ((A_0.i > A_1.i) ? A_0.i : A_1.i);
	}

	public static a g(a A_0, a A_1)
	{
		c(ref A_0, ref A_1, out a A_2);
		return A_2;
	}

	public static void b(ref a A_0, ref a A_1, out a A_2)
	{
		A_2.g = ((A_0.g < A_1.g) ? A_0.g : A_1.g);
		A_2.h = ((A_0.h < A_1.h) ? A_0.h : A_1.h);
		A_2.i = ((A_0.i < A_1.i) ? A_0.i : A_1.i);
	}

	public static a f(a A_0, a A_1)
	{
		b(ref A_0, ref A_1, out a A_2);
		return A_2;
	}

	public static void b(ref a A_0, float A_1, float A_2, float A_3, float A_4, float A_5, float A_6, ref q A_7, out a A_8)
	{
		a A_9 = default(a);
		b(ref A_0, ref A_7, out A_9);
		A_8 = new a((1f + A_9.g) * 0.5f * A_3 + A_1, (1f - A_9.h) * 0.5f * A_4 + A_2, A_9.i * (A_6 - A_5) + A_5);
	}

	public static a b(a A_0, float A_1, float A_2, float A_3, float A_4, float A_5, float A_6, q A_7)
	{
		b(ref A_0, A_1, A_2, A_3, A_4, A_5, A_6, ref A_7, out var A_8);
		return A_8;
	}

	public static void a(ref a A_0, float A_1, float A_2, float A_3, float A_4, float A_5, float A_6, ref q A_7, out a A_8)
	{
		a A_9 = default(a);
		q A_10 = default(q);
		q.f(ref A_7, out A_10);
		A_9.g = (A_0.g - A_1) / A_3 * 2f - 1f;
		A_9.h = 0f - ((A_0.h - A_2) / A_4 * 2f - 1f);
		A_9.i = (A_0.i - A_5) / (A_6 - A_5);
		b(ref A_9, ref A_10, out A_8);
	}

	public static a a(a A_0, float A_1, float A_2, float A_3, float A_4, float A_5, float A_6, q A_7)
	{
		a(ref A_0, A_1, A_2, A_3, A_4, A_5, A_6, ref A_7, out var A_8);
		return A_8;
	}

	public static void a(ref a A_0, ref a A_1, out a A_2)
	{
		float num = A_0.g * A_1.g + A_0.h * A_1.h + A_0.i * A_1.i;
		A_2.g = A_0.g - 2f * num * A_1.g;
		A_2.h = A_0.h - 2f * num * A_1.h;
		A_2.i = A_0.i - 2f * num * A_1.i;
	}

	public static a e(a A_0, a A_1)
	{
		a(ref A_0, ref A_1, out a A_2);
		return A_2;
	}

	public static void b(a[] A_0, params a[] A_1)
	{
		if (A_1 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_0.Length < A_1.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_1.Length; num++)
		{
			a a2 = A_1[num];
			for (int num2 = 0; num2 < num; num2++)
			{
				a2 = c(a2, a(h(A_0[num2], a2) / h(A_0[num2], A_0[num2]), A_0[num2]));
			}
			A_0[num] = a2;
		}
	}

	public static void a(a[] A_0, params a[] A_1)
	{
		if (A_1 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_0.Length < A_1.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_1.Length; num++)
		{
			a a2 = A_1[num];
			for (int num2 = 0; num2 < num; num2++)
			{
				a2 = c(a2, a(h(A_0[num2], a2), A_0[num2]));
			}
			a2.a();
			A_0[num] = a2;
		}
	}

	public static void a(ref a A_0, ref v A_1, out a A_2)
	{
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		A_2 = new a(A_0.g * (1f - num10 - num12) + A_0.h * (num8 - num6) + A_0.i * (num9 + num5), A_0.g * (num8 + num6) + A_0.h * (1f - num7 - num12) + A_0.i * (num11 - num4), A_0.g * (num9 - num5) + A_0.h * (num11 + num4) + A_0.i * (1f - num7 - num10));
	}

	public static a a(a A_0, v A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(a[] A_0, ref v A_1, a[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		float num13 = 1f - num10 - num12;
		float num14 = num8 - num6;
		float num15 = num9 + num5;
		float num16 = num8 + num6;
		float num17 = 1f - num7 - num12;
		float num18 = num11 - num4;
		float num19 = num9 - num5;
		float num20 = num11 + num4;
		float num21 = 1f - num7 - num10;
		for (int num22 = 0; num22 < A_0.Length; num22++)
		{
			ref a reference = ref A_2[num22];
			reference = new a(A_0[num22].g * num13 + A_0[num22].h * num14 + A_0[num22].i * num15, A_0[num22].g * num16 + A_0[num22].h * num17 + A_0[num22].i * num18, A_0[num22].g * num19 + A_0[num22].h * num20 + A_0[num22].i * num21);
		}
	}

	public static void a(ref a A_0, ref q A_1, out i A_2)
	{
		A_2 = new i(A_0.g * A_1.d + A_0.h * A_1.h + A_0.i * A_1.l + A_1.p, A_0.g * A_1.e + A_0.h * A_1.i + A_0.i * A_1.m + A_1.q, A_0.g * A_1.f + A_0.h * A_1.j + A_0.i * A_1.n + A_1.r, A_0.g * A_1.g + A_0.h * A_1.k + A_0.i * A_1.o + A_1.s);
	}

	public static i c(a A_0, q A_1)
	{
		a(ref A_0, ref A_1, out i A_2);
		return A_2;
	}

	public static void a(a[] A_0, ref q A_1, i[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			a(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	public static void b(ref a A_0, ref q A_1, out a A_2)
	{
		i i2 = default(i);
		i2.h = A_0.g * A_1.d + A_0.h * A_1.h + A_0.i * A_1.l + A_1.p;
		i2.i = A_0.g * A_1.e + A_0.h * A_1.i + A_0.i * A_1.m + A_1.q;
		i2.j = A_0.g * A_1.f + A_0.h * A_1.j + A_0.i * A_1.n + A_1.r;
		i2.k = 1f / (A_0.g * A_1.g + A_0.h * A_1.k + A_0.i * A_1.o + A_1.s);
		A_2 = new a(i2.h * i2.k, i2.i * i2.k, i2.j * i2.k);
	}

	public static a b(a A_0, q A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(a[] A_0, ref q A_1, a[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			b(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	public static void a(ref a A_0, ref q A_1, out a A_2)
	{
		A_2 = new a(A_0.g * A_1.d + A_0.h * A_1.h + A_0.i * A_1.l, A_0.g * A_1.e + A_0.h * A_1.i + A_0.i * A_1.m, A_0.g * A_1.f + A_0.h * A_1.j + A_0.i * A_1.n);
	}

	public static a a(a A_0, q A_1)
	{
		a(ref A_0, ref A_1, out a A_2);
		return A_2;
	}

	public static void a(a[] A_0, ref q A_1, a[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			a(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	[SpecialName]
	public static a d(a A_0, a A_1)
	{
		return new a(A_0.g + A_1.g, A_0.h + A_1.h, A_0.i + A_1.i);
	}

	[SpecialName]
	public static a d(a A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static a c(a A_0, a A_1)
	{
		return new a(A_0.g - A_1.g, A_0.h - A_1.h, A_0.i - A_1.i);
	}

	[SpecialName]
	public static a c(a A_0)
	{
		return new a(0f - A_0.g, 0f - A_0.h, 0f - A_0.i);
	}

	[SpecialName]
	public static a a(float A_0, a A_1)
	{
		return new a(A_1.g * A_0, A_1.h * A_0, A_1.i * A_0);
	}

	[SpecialName]
	public static a b(a A_0, float A_1)
	{
		return new a(A_0.g * A_1, A_0.h * A_1, A_0.i * A_1);
	}

	[SpecialName]
	public static a a(a A_0, float A_1)
	{
		return new a(A_0.g / A_1, A_0.h / A_1, A_0.i / A_1);
	}

	[SpecialName]
	public static bool b(a A_0, a A_1)
	{
		return A_0.g(A_1);
	}

	[SpecialName]
	public static bool a(a A_0, a A_1)
	{
		return !A_0.g(A_1);
	}

	[SpecialName]
	public static au b(a A_0)
	{
		return new au(A_0.g, A_0.h);
	}

	[SpecialName]
	public static i a(a A_0)
	{
		return new i(A_0, 0f);
	}

	public string g()
	{
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2}", new object[3] { this.g, this.h, this.i });
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2}", new object[3]
		{
			this.g.ToString(A_0, CultureInfo.CurrentCulture),
			this.h.ToString(A_0, CultureInfo.CurrentCulture),
			this.i.ToString(A_0, CultureInfo.CurrentCulture)
		});
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "X:{0} Y:{1} Z:{2}", new object[3] { this.g, this.h, this.i });
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			return a(A_1);
		}
		return string.Format(A_1, "X:{0} Y:{1} Z:{2}", new object[3]
		{
			this.g.ToString(A_0, A_1),
			this.h.ToString(A_0, A_1),
			this.i.ToString(A_0, A_1)
		});
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int f()
	{
		return this.g.GetHashCode() + this.h.GetHashCode() + this.i.GetHashCode();
	}

	public bool g(a A_0)
	{
		if (Math.Abs(A_0.g - this.g) < 1E-06f && Math.Abs(A_0.h - this.h) < 1E-06f)
		{
			return Math.Abs(A_0.i - this.i) < 1E-06f;
		}
		return false;
	}

	bool IEquatable<a>.Equals(a A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in g
		return this.g(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return g((a)A_0);
	}
}
