using System;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
public struct ap : IEquatable<ap>, IFormattable
{
	public a a;

	public float b;

	public ap(float A_0)
	{
		this.a.g = (this.a.h = (this.a.i = (this.b = A_0)));
	}

	public ap(float A_0, float A_1, float A_2, float A_3)
	{
		this.a.g = A_0;
		this.a.h = A_1;
		this.a.i = A_2;
		this.b = A_3;
	}

	public ap(a A_0, a A_1)
	{
		this.a = A_1;
		this.b = 0f - SharpDX.a.h(A_1, A_0);
	}

	public ap(a A_0, float A_1)
	{
		this.a = A_0;
		this.b = A_1;
	}

	public ap(a A_0, a A_1, a A_2)
	{
		float num = A_1.g - A_0.g;
		float num2 = A_1.h - A_0.h;
		float num3 = A_1.i - A_0.i;
		float num4 = A_2.g - A_0.g;
		float num5 = A_2.h - A_0.h;
		float num6 = A_2.i - A_0.i;
		float num7 = num2 * num6 - num3 * num5;
		float num8 = num3 * num4 - num * num6;
		float num9 = num * num5 - num2 * num4;
		float num10 = 1f / (float)Math.Sqrt(num7 * num7 + num8 * num8 + num9 * num9);
		this.a.g = num7 * num10;
		this.a.h = num8 * num10;
		this.a.i = num9 * num10;
		this.b = 0f - (this.a.g * A_0.g + this.a.h * A_0.h + this.a.i * A_0.i);
	}

	public ap(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 4)
		{
			throw new ArgumentOutOfRangeException("values", "There must be four and only four input values for Plane.");
		}
		this.a.g = A_0[0];
		this.a.h = A_0[1];
		this.a.i = A_0[2];
		this.b = A_0[3];
	}

	[SpecialName]
	public float a(int A_0)
	{
		return A_0 switch
		{
			0 => this.a.g, 
			1 => this.a.h, 
			2 => this.a.i, 
			3 => this.b, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Plane run from 0 to 3, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.a.g = A_1;
			break;
		case 1:
			this.a.h = A_1;
			break;
		case 2:
			this.a.i = A_1;
			break;
		case 3:
			this.b = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Plane run from 0 to 3, inclusive.");
		}
	}

	public void a()
	{
		float num = 1f / (float)Math.Sqrt(this.a.g * this.a.g + this.a.h * this.a.h + this.a.i * this.a.i);
		this.a.g *= num;
		this.a.h *= num;
		this.a.i *= num;
		this.b *= num;
	}

	public float[] b()
	{
		return new float[4]
		{
			this.a.g,
			this.a.h,
			this.a.i,
			this.b
		};
	}

	public b a(ref a A_0)
	{
		return ar.a(ref this, ref A_0);
	}

	public bool a(ref ac A_0)
	{
		float A_1;
		return ar.a(ref A_0, ref this, out A_1);
	}

	public bool a(ref ac A_0, out float A_1)
	{
		return ar.a(ref A_0, ref this, out A_1);
	}

	public bool a(ref ac A_0, out a A_1)
	{
		return ar.a(ref A_0, ref this, out A_1);
	}

	public bool a(ref ap A_0)
	{
		return ar.a(ref this, ref A_0);
	}

	public bool a(ref ap A_0, out ac A_1)
	{
		return ar.a(ref this, ref A_0, out A_1);
	}

	public b a(ref a A_0, ref a A_1, ref a A_2)
	{
		return ar.a(ref this, ref A_0, ref A_1, ref A_2);
	}

	public b a(ref j A_0)
	{
		return ar.a(ref this, ref A_0);
	}

	public b a(ref y A_0)
	{
		return ar.a(ref this, ref A_0);
	}

	public static void a(ref ap A_0, float A_1, out ap A_2)
	{
		A_2.a.g = A_0.a.g * A_1;
		A_2.a.h = A_0.a.h * A_1;
		A_2.a.i = A_0.a.i * A_1;
		A_2.b = A_0.b * A_1;
	}

	public static ap b(ap A_0, float A_1)
	{
		return new ap(A_0.a.g * A_1, A_0.a.h * A_1, A_0.a.i * A_1, A_0.b * A_1);
	}

	public static void a(ref ap A_0, ref i A_1, out float A_2)
	{
		A_2 = A_0.a.g * A_1.h + A_0.a.h * A_1.i + A_0.a.i * A_1.j + A_0.b * A_1.k;
	}

	public static float a(ap A_0, i A_1)
	{
		return A_0.a.g * A_1.h + A_0.a.h * A_1.i + A_0.a.i * A_1.j + A_0.b * A_1.k;
	}

	public static void b(ref ap A_0, ref a A_1, out float A_2)
	{
		A_2 = A_0.a.g * A_1.g + A_0.a.h * A_1.h + A_0.a.i * A_1.i + A_0.b;
	}

	public static float b(ap A_0, a A_1)
	{
		return A_0.a.g * A_1.g + A_0.a.h * A_1.h + A_0.a.i * A_1.i + A_0.b;
	}

	public static void a(ref ap A_0, ref a A_1, out float A_2)
	{
		A_2 = A_0.a.g * A_1.g + A_0.a.h * A_1.h + A_0.a.i * A_1.i;
	}

	public static float a(ap A_0, a A_1)
	{
		return A_0.a.g * A_1.g + A_0.a.h * A_1.h + A_0.a.i * A_1.i;
	}

	public static void a(ref ap A_0, out ap A_1)
	{
		float num = 1f / (float)Math.Sqrt(A_0.a.g * A_0.a.g + A_0.a.h * A_0.a.h + A_0.a.i * A_0.a.i);
		A_1.a.g = A_0.a.g * num;
		A_1.a.h = A_0.a.h * num;
		A_1.a.i = A_0.a.i * num;
		A_1.b = A_0.b * num;
	}

	public static ap a(ap A_0)
	{
		float num = 1f / (float)Math.Sqrt(A_0.a.g * A_0.a.g + A_0.a.h * A_0.a.h + A_0.a.i * A_0.a.i);
		return new ap(A_0.a.g * num, A_0.a.h * num, A_0.a.i * num, A_0.b * num);
	}

	public static void a(ref ap A_0, ref v A_1, out ap A_2)
	{
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		float num13 = A_0.a.g;
		float num14 = A_0.a.h;
		float num15 = A_0.a.i;
		A_2.a.g = num13 * (1f - num10 - num12) + num14 * (num8 - num6) + num15 * (num9 + num5);
		A_2.a.h = num13 * (num8 + num6) + num14 * (1f - num7 - num12) + num15 * (num11 - num4);
		A_2.a.i = num13 * (num9 - num5) + num14 * (num11 + num4) + num15 * (1f - num7 - num10);
		A_2.b = A_0.b;
	}

	public static ap a(ap A_0, v A_1)
	{
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		float num13 = A_0.a.g;
		float num14 = A_0.a.h;
		float num15 = A_0.a.i;
		ap result = default(ap);
		result.a.g = num13 * (1f - num10 - num12) + num14 * (num8 - num6) + num15 * (num9 + num5);
		result.a.h = num13 * (num8 + num6) + num14 * (1f - num7 - num12) + num15 * (num11 - num4);
		result.a.i = num13 * (num9 - num5) + num14 * (num11 + num4) + num15 * (1f - num7 - num10);
		result.b = A_0.b;
		return result;
	}

	public static void a(ap[] A_0, ref v A_1)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("planes");
		}
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		for (int num13 = 0; num13 < A_0.Length; num13++)
		{
			float num14 = A_0[num13].a.g;
			float num15 = A_0[num13].a.h;
			float num16 = A_0[num13].a.i;
			A_0[num13].a.g = num14 * (1f - num10 - num12) + num15 * (num8 - num6) + num16 * (num9 + num5);
			A_0[num13].a.h = num14 * (num8 + num6) + num15 * (1f - num7 - num12) + num16 * (num11 - num4);
			A_0[num13].a.i = num14 * (num9 - num5) + num15 * (num11 + num4) + num16 * (1f - num7 - num10);
		}
	}

	public static void a(ref ap A_0, ref q A_1, out ap A_2)
	{
		float num = A_0.a.g;
		float num2 = A_0.a.h;
		float num3 = A_0.a.i;
		float num4 = A_0.b;
		q.f(ref A_1, out var A_3);
		A_2.a.g = num * A_3.d + num2 * A_3.e + num3 * A_3.f + num4 * A_3.g;
		A_2.a.h = num * A_3.h + num2 * A_3.i + num3 * A_3.j + num4 * A_3.k;
		A_2.a.i = num * A_3.l + num2 * A_3.m + num3 * A_3.n + num4 * A_3.o;
		A_2.b = num * A_3.p + num2 * A_3.q + num3 * A_3.r + num4 * A_3.s;
	}

	public static ap a(ap A_0, q A_1)
	{
		float num = A_0.a.g;
		float num2 = A_0.a.h;
		float num3 = A_0.a.i;
		float num4 = A_0.b;
		A_1.h();
		ap result = default(ap);
		result.a.g = num * A_1.d + num2 * A_1.e + num3 * A_1.f + num4 * A_1.g;
		result.a.h = num * A_1.h + num2 * A_1.i + num3 * A_1.j + num4 * A_1.k;
		result.a.i = num * A_1.l + num2 * A_1.m + num3 * A_1.n + num4 * A_1.o;
		result.b = num * A_1.p + num2 * A_1.q + num3 * A_1.r + num4 * A_1.s;
		return result;
	}

	public static void a(ap[] A_0, ref q A_1)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("planes");
		}
		q.f(ref A_1, out var _);
		for (int num = 0; num < A_0.Length; num++)
		{
			a(ref A_0[num], ref A_1, out A_0[num]);
		}
	}

	[SpecialName]
	public static ap a(float A_0, ap A_1)
	{
		return new ap(A_1.a.g * A_0, A_1.a.h * A_0, A_1.a.i * A_0, A_1.b * A_0);
	}

	[SpecialName]
	public static ap a(ap A_0, float A_1)
	{
		return new ap(A_0.a.g * A_1, A_0.a.h * A_1, A_0.a.i * A_1, A_0.b * A_1);
	}

	[SpecialName]
	public static bool b(ap A_0, ap A_1)
	{
		return A_0.b(A_1);
	}

	[SpecialName]
	public static bool a(ap A_0, ap A_1)
	{
		return !A_0.b(A_1);
	}

	public string c()
	{
		return string.Format(CultureInfo.CurrentCulture, "A:{0} B:{1} C:{2} D:{3}", this.a.g, this.a.h, this.a.i, this.b);
	}

	public string a(string A_0)
	{
		return string.Format(CultureInfo.CurrentCulture, "A:{0} B:{1} C:{2} D:{3}", this.a.g.ToString(A_0, CultureInfo.CurrentCulture), this.a.h.ToString(A_0, CultureInfo.CurrentCulture), this.a.i.ToString(A_0, CultureInfo.CurrentCulture), this.b.ToString(A_0, CultureInfo.CurrentCulture));
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "A:{0} B:{1} C:{2} D:{3}", this.a.g, this.a.h, this.a.i, this.b);
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		return string.Format(A_1, "A:{0} B:{1} C:{2} D:{3}", this.a.g.ToString(A_0, A_1), this.a.h.ToString(A_0, A_1), this.a.i.ToString(A_0, A_1), this.b.ToString(A_0, A_1));
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int d()
	{
		return this.a.GetHashCode() + this.b.GetHashCode();
	}

	public bool b(ap A_0)
	{
		if (SharpDX.a.b(this.a, A_0.a))
		{
			return this.b == A_0.b;
		}
		return false;
	}

	bool IEquatable<ap>.Equals(ap A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in b
		return this.b(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return b((ap)A_0);
	}
}
