using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Drawing;
using System.IO;
using System.Net;
using System.Xml;
using Com.Raritan.RcCore;
using log4net;

namespace Com.Raritan.KxGui;

internal class o
{
	private const string m_a = "param";

	private const string b = "PortPermission";

	private const string c = "PortId";

	private const string d = "TARGET_PORT";

	private const string e = "PortName";

	private const string f = "PortType";

	private const string g = "SESSION_ID";

	private const string h = "error";

	private const string j = "MultiMonitorMode";

	private const string k = "MonitorHPosition";

	private const string l = "MonitorVPosition";

	private const string m = "SECONDARY_PORT";

	private const string n = "SecondaryPortPermission";

	private const string o = "SecondaryPortId";

	private const string p = "SecondaryPortName";

	private const string q = "SecondaryPortType";

	private const string r = "SecondaryMonitorHPosition";

	private const string s = "SecondaryMonitorVPosition";

	private static ILog i = LogManager.GetLogger(typeof(o));

	internal static Dictionary<string, string> a(string A_0)
	{
		//IL_0006: Unknown result type (might be due to invalid IL or missing references)
		//IL_000c: Expected O, but got Unknown
		//IL_0023: Unknown result type (might be due to invalid IL or missing references)
		//IL_0028: Unknown result type (might be due to invalid IL or missing references)
		//IL_002a: Unknown result type (might be due to invalid IL or missing references)
		//IL_002d: Invalid comparison between Unknown and I4
		//IL_004a: Unknown result type (might be due to invalid IL or missing references)
		//IL_0050: Invalid comparison between Unknown and I4
		Dictionary<string, string> dictionary = new Dictionary<string, string>();
		XmlReaderSettings val = new XmlReaderSettings();
		val.ConformanceLevel = (ConformanceLevel)1;
		XmlReader val2 = XmlReader.Create((TextReader)new StringReader(A_0), val);
		try
		{
			while (val2.Read())
			{
				XmlNodeType nodeType = val2.NodeType;
				if ((int)nodeType != 1)
				{
					continue;
				}
				if ("error".Equals(val2.Name))
				{
					if (val2.Read() && (int)val2.NodeType == 3)
					{
						dictionary.Add("error", val2.Value);
					}
				}
				else if ("param".Equals(val2.Name))
				{
					string attribute = val2.GetAttribute("name");
					if (attribute != null)
					{
						dictionary.Add(attribute, val2.GetAttribute("value"));
					}
				}
			}
			return dictionary;
		}
		catch (Exception exception)
		{
			i.Error("Error parsing KXDpa connection params", exception);
			return null;
		}
		finally
		{
			((IDisposable)val2)?.Dispose();
		}
	}

	internal static void a(string A_0, IPAddress A_1, int A_2, out Com.Raritan.RcCore.a A_3, out a A_4)
	{
		Dictionary<string, string> dictionary = a(A_0);
		if (dictionary == null)
		{
			string text = "Failed to Parse the connection data provided by KXDpa";
			i.Error(text);
			throw new g.c(text, Com.Raritan.KxGui.g.f.e);
		}
		i.Debug("CSCInfo params from KxDpa");
		foreach (KeyValuePair<string, string> item in dictionary)
		{
			i.Debug("Param - " + item.Key + " : " + item.Value);
		}
		if (dictionary.ContainsKey("error"))
		{
			int.TryParse(dictionary["error"], out var result);
			throw new g.c(result, Com.Raritan.KxGui.g.f.t);
		}
		if (!dictionary.ContainsKey("PortId"))
		{
			string text2 = "Missing PortID";
			i.Error(text2);
			throw new g.c(text2, Com.Raritan.KxGui.g.f.p);
		}
		if (!dictionary.ContainsKey("PortName"))
		{
			string text3 = "Missing PortName";
			i.Error(text3);
			throw new g.c(text3, Com.Raritan.KxGui.g.f.q);
		}
		if (!dictionary.ContainsKey("TARGET_PORT"))
		{
			string text4 = "Missing Target_port";
			i.Error(text4);
			throw new g.c(text4, Com.Raritan.KxGui.g.f.r);
		}
		dictionary.TryGetValue("PortPermission", out var value);
		Com.Raritan.RcCore.a.a a_ = Com.Raritan.KxGui.g.b(value);
		Com.Raritan.RcCore.a.b a_2 = Com.Raritan.KxGui.g.c(value);
		dictionary.TryGetValue("PortType", out var value2);
		bool a_3 = Com.Raritan.KxGui.g.a(value2);
		if (dictionary.ContainsKey("MultiMonitorMode") && dictionary["MultiMonitorMode"].ToUpperInvariant().Equals("TRUE"))
		{
			int result2 = 0;
			int result3 = 0;
			int result4 = 0;
			int result5 = 0;
			if (!dictionary.ContainsKey("MonitorHPosition") || !int.TryParse(dictionary["MonitorHPosition"], out result2))
			{
				i.Warn("Monitor H Position not found or invalid");
			}
			if (!dictionary.ContainsKey("MonitorVPosition") || !int.TryParse(dictionary["MonitorVPosition"], out result3))
			{
				i.Warn("Monitor V Position not found or invalid");
			}
			if (!dictionary.ContainsKey("SecondaryPortId"))
			{
				string text5 = "Missing Secondary PortID";
				i.Error(text5);
				throw new g.c(text5, Com.Raritan.KxGui.g.f.p);
			}
			if (!dictionary.ContainsKey("SecondaryPortName"))
			{
				string text6 = "Missing Secondary PortName";
				i.Error(text6);
				throw new g.c(text6, Com.Raritan.KxGui.g.f.q);
			}
			if (!dictionary.ContainsKey("SECONDARY_PORT"))
			{
				string text7 = "Missing Secondary port";
				i.Error(text7);
				throw new g.c(text7, Com.Raritan.KxGui.g.f.r);
			}
			dictionary.TryGetValue("SecondaryPortPermission", out var value3);
			Com.Raritan.RcCore.a.a a_4 = Com.Raritan.KxGui.g.b(value3);
			Com.Raritan.RcCore.a.b a_5 = Com.Raritan.KxGui.g.c(value3);
			dictionary.TryGetValue("SecondaryPortType", out var value4);
			bool a_6 = Com.Raritan.KxGui.g.a(value4);
			if (!dictionary.ContainsKey("SecondaryMonitorHPosition") || !int.TryParse(dictionary["SecondaryMonitorHPosition"], out result4))
			{
				i.Warn("Secondary Monitor H Position not found or invalid");
			}
			if (!dictionary.ContainsKey("SecondaryMonitorVPosition") || !int.TryParse(dictionary["SecondaryMonitorVPosition"], out result5))
			{
				i.Warn("Secondary Monitor V Position not found or invalid");
			}
			aj aj2 = new aj(dictionary["TARGET_PORT"], dictionary["PortId"], dictionary["PortName"], a_, a_2, a_3, 0, new Point(result2, result3));
			aj2.i().Add(new ai(aj2, dictionary["SECONDARY_PORT"], dictionary["SecondaryPortId"], dictionary["SecondaryPortName"], a_4, a_5, a_6, 1, new Point(result4, result5)));
			A_3 = aj2;
		}
		else
		{
			A_3 = new Com.Raritan.RcCore.a(dictionary["TARGET_PORT"], dictionary["PortId"], dictionary["PortName"], a_, a_2, a_3);
		}
		if (!dictionary.ContainsKey("SESSION_ID"))
		{
			string text8 = "Missing SessionKey";
			i.Error(text8);
			throw new g.c(text8, Com.Raritan.KxGui.g.f.k);
		}
		bool a_7 = false;
		if (dictionary.TryGetValue("SSL", out var value5) && (value5.ToUpperInvariant().Equals("YES") || value5.ToUpperInvariant().Equals("FORCE") || value5.ToUpperInvariant().Equals("TRY")))
		{
			a_7 = true;
		}
		A_4 = new a(A_1.ToString(), A_2, a_7, dictionary["SESSION_ID"]);
	}

	internal static void a(string A_0, NameValueCollection A_1, IPAddress A_2, int A_3, l A_4, out Com.Raritan.RcCore.a A_5, out a A_6)
	{
		Uri uri;
		try
		{
			uri = new Uri(A_0);
		}
		catch (Exception ex)
		{
			string text = "Exception on parsing the url";
			i.Error(text, ex);
			throw new g.c(text, ex, Com.Raritan.KxGui.g.f.b);
		}
		i.Debug("Performing a HTPPS Get on " + uri);
		string text2;
		try
		{
			text2 = A_4.a(uri, null);
		}
		catch (TimeoutException ex2)
		{
			string text3 = "Timeout occured on connecting to KX";
			i.Error(text3, ex2);
			throw new g.c(text3, ex2, Com.Raritan.KxGui.g.f.m);
		}
		catch (Exception ex3)
		{
			string text4 = "Exception occured on connecting to KX";
			i.Error(text4, ex3);
			throw new g.c(text4, ex3, Com.Raritan.KxGui.g.f.n);
		}
		if (text2 == null)
		{
			string text5 = "Failed to GETResponse from KX";
			i.Error(text5);
			throw new g.c(text5, Com.Raritan.KxGui.g.f.n);
		}
		i.Debug("HTTPSGetResponse : " + text2);
		a(text2, A_2, A_3, out A_5, out A_6);
	}
}
